SGATCC/Areas/Coordenador/Models/Aula.cs
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace SGATCC.Areas.Coordenador.Models
{
    public class Aula
    {
        [Key]
        public int Id { get; set; }

        [ForeignKey("Disciplina")]
        public int DisciplinaId { get; set; }
        public Disciplina Disciplina { get; set; }

        [ForeignKey("Aluno")]
        public int AlunoId { get; set; }
        public Aluno Aluno { get; set; }

        public bool FreqAula1 { get; set; }
        public bool FreqAula2 { get; set; }
        public bool FreqAula3 { get; set; }
        public bool FreqAula4 { get; set; }
        public bool FreqAula5 { get; set; }
    }
}

SGATCC/Areas/Coordenador/Models/Nota.cs
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace SGATCC.Areas.Coordenador.Models
{
    public class Nota
    {
        public int Id { get; set; }
        [ForeignKey("Aluno")]
        public int AlunoId { get; set; }
        public Aluno Aluno { get; set; }

        [ForeignKey("Disciplina")]
        public int DisciplinaId { get; set; }
        public Disciplina Disciplina { get; set; }
        [Display(Name = "Nota")]
        [Range(0.0,100)]
        public double ValorNota { get; set; }
        public bool Aprovado { get; set; }

    }
}

SGATCC/Areas/Coordenador/Controllers/LancamentosController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using SGATCC.Areas.Coordenador.Models;
using SGATCC.Areas.Coordenador.ViewModel;
using SGATCC.Contexto;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace SGATCC.Areas.Coordenador.Controllers
{
    [Area("Coordenador")]
    [Authorize(Roles = "Coordenador,Professor")]
    public class LancamentosController : Controller
    {
        private readonly ContextoSGATCC _context;
        public LancamentosController(ContextoSGATCC context)
        {
            _context = context;
        }
        public IActionResult Index()
        {
            var dadosCursos = _context.Cursos.ToList();
            var listaCursos = new List<SelectListItem> { new SelectListItem { Text = "Selecione o Curso", Value = "" } };
            listaCursos.AddRange(dadosCursos.Select(x => new SelectListItem { Text = x.Descricao, Value = x.Id.ToString() }));

            ViewBag.lstCursos = listaCursos;
            return View();
        }

        public JsonResult BuscarTurnosDoCurso([FromQuery] string cursoId)
        {
            var dados = _context.Turmas.Include(x => x.Turno).Where(x => x.CursoId == int.Parse(cursoId)).Distinct().ToList();

            var dadosFiltrados = new List<Turno>();

            dados.ForEach(x =>
            {
                var existe = dadosFiltrados.FirstOrDefault(y => y.TurnoId == x.Turno.TurnoId);

                if (existe == null)
                {
                    dadosFiltrados.Add(x.Turno);
                }

            });

            return Json(dadosFiltrados.Select(x => new
            {
                Id = x.TurnoId,
                Turno = x.Descricao
            }));
        }

        public async Task<JsonResult> BuscarDisciplinasDoCurso([FromQuery] string cursoId, [FromQuery] string turnoId)
        {
            var dados = await _context.Turmas.Include(x => x.Professor)
                .ThenInclude(y => y.Disciplina)
                .Where(x => x.CursoId == int.Parse(cursoId) && x.TurnoId == int.Parse(turnoId))
                .ToListAsync();

            return Json(dados.Select(x => new
            {
                Id = x.Professor.Disciplina.Id,
                Disciplina = x.Professor.Disciplina.Descricao,
            }));
        }

        [HttpPost]
        public IActionResult BuscarAlunos(FiltroNotasEChamadaViewModel viewModel)
        {
            var dadosAlunos = _context.Alunos.Where(x => x.CursoId == int.Parse(viewModel.Curso) && x.TurnoId == int.Parse(viewModel.Turno)).ToList();

            if (!string.IsNullOrEmpty(viewModel.NomeAluno))
                dadosAlunos = dadosAlunos.Where(x => x.Nome.ToLower().Contains(viewModel.NomeAluno.ToLower())).ToList();

            var dadosDisciplina = _context.Disciplinas.FirstOrDefault(x => x.Id == int.Parse(viewModel.Disciplina));

            var lstAlunos = dadosAlunos.Select(x => new CriarAlunoViewModel
            {
                AlunoId = x.Id,
                Matricula = x.Matricula,
                Nome = x.Nome,
                DataNascimento = x.DataNascimento,
                Disciplina = dadosDisciplina.Descricao
            }).ToList();

            return PartialView("_LstAlunos", lstAlunos);
        }

        [HttpGet]
        public async Task<IActionResult> Frequencia(string alunoId, string disciplina)
        {
            var disciplinaEntidade = await _context.Disciplinas
                .FirstOrDefaultAsync(x => x.Descricao.ToLower().Contains(disciplina.ToLower()));

            var aulaEntidade = await _context.Aulas
                .FirstOrDefaultAsync(x => x.AlunoId == int.Parse(alunoId) && x.DisciplinaId == disciplinaEntidade.Id);

            var aula = new AulaViewModel
            {
                DisciplinaId = disciplinaEntidade.Id,
                AlunoId = int.Parse(alunoId)
            };

            if (aulaEntidade != null)
            {
                aula.Aula1 = aulaEntidade.FreqAula1;
                aula.Aula2 = aulaEntidade.FreqAula2;
                aula.Aula3 = aulaEntidade.FreqAula3;
                aula.Aula4 = aulaEntidade.FreqAula4;
                aula.Aula5 = aulaEntidade.FreqAula5;
            }

            return PartialView("_Aula", aula);

        }

        [HttpGet]
        public async Task<IActionResult> Nota(string alunoId, string disciplina)
        {
            var disciplinaEntidade = await _context.Disciplinas
              .FirstOrDefaultAsync(x => x.Descricao.ToLower().Contains(disciplina.ToLower()));

            var notaEntidade = await _context.Notas
                .FirstOrDefaultAsync(x => x.AlunoId == int.Parse(alunoId) && x.DisciplinaId == disciplinaEntidade.Id);

            var nota = new Nota
            {
                AlunoId = int.Parse(alunoId),
                DisciplinaId = disciplinaEntidade.Id
            };

            if (notaEntidade != null)
            {
                nota.ValorNota = notaEntidade.ValorNota;
            }

            return PartialView("_Nota", nota);
        }

        [HttpPost]
        public IActionResult LancarNota(Nota viewModel)
        {
            var nota = _context.Notas.FirstOrDefault(x => x.AlunoId == viewModel.AlunoId && x.DisciplinaId == viewModel.DisciplinaId);

            try
            {
                if (nota is null)
                {
                    _context.Notas.Add(new Nota
                    {
                        DisciplinaId = viewModel.DisciplinaId,
                        AlunoId = viewModel.AlunoId,
                        ValorNota = viewModel.ValorNota,
                        Aprovado = viewModel.Aprovado
                    });
                }
                else
                {
                    nota.ValorNota = viewModel.ValorNota;
                    nota.Aprovado = viewModel.Aprovado;
                    _context.Notas.Update(nota);
                }

                _context.SaveChanges();
                return Json(new { Erro = false, Msg = "Nota Lançada" });
            }
            catch (Exception ex)
            {

                return Json(new { Erro = true, Msg = ex.Message });
            }
        }

        [HttpPost]
        public IActionResult LancarFrequencia(AulaViewModel viewModel)
        {
            var aula = _context.Aulas.FirstOrDefault(x => x.AlunoId == viewModel.AlunoId && x.DisciplinaId == viewModel.DisciplinaId);

            try
            {
                if (aula is null)
                {
                    _context.Aulas.Add(new Aula
                    {
                        DisciplinaId = viewModel.DisciplinaId,
                        AlunoId = viewModel.AlunoId,
                        FreqAula1 = viewModel.Aula1,
                        FreqAula2 = viewModel.Aula2,
                        FreqAula3 = viewModel.Aula3,
                        FreqAula4 = viewModel.Aula4,
                        FreqAula5 = viewModel.Aula5,
                    });
                }
                else
                {
                    aula.FreqAula1 = viewModel.Aula1;
                    aula.FreqAula2 = viewModel.Aula2;
                    aula.FreqAula3 = viewModel.Aula3;
                    aula.FreqAula4 = viewModel.Aula4;
                    aula.FreqAula5 = viewModel.Aula5;
                    _context.Aulas.Update(aula);
                }

                _context.SaveChanges();
                return Json(new { Erro = false, Msg = "Frequencia Lancada" });
            }
            catch (Exception ex)
            {

                return Json(new { Erro = true, Msg = ex.Message });
            }
        }
    }
}

SGATCC/Areas/Coordenador/Views/Lancamentos/Index.cshtml
@model SGATCC.Areas.Coordenador.ViewModel.FiltroNotasEChamadaViewModel

<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Buscar Alunos
        </div>
    </div>
    <div class="card-body">
        <form asp-action="BuscarAlunos" asp-controller="Lancamentos" asp-area="Coordenador" data-ajax="true"
              data-ajax-method="post"
              data-ajax-update="#resultado"
              data-ajax-begin="alunosBegin"
              data-ajax-success="alunosSuccess"
              id="formAlunos">
            <div class="row">
                <div class="col-md-3">
                    <label asp-for="Curso"></label>
                    <select asp-for="Curso" asp-items="ViewBag.lstCursos" class="form-control"></select>
                </div>
                <div class="col-md-3">
                    <label asp-for="Turno"></label>
                    <select asp-for="Turno" class="form-control"></select>
                </div>
                <div class="col-md-3">
                    <label asp-for="Disciplina"></label>
                    <select asp-for="Disciplina" class="form-control"></select>
                </div>
                <div class="col-md-3">
                    <label asp-for="NomeAluno"></label>
                    <input asp-for="NomeAluno" class="form-control" placeholder="Opcional" />
                </div>
            </div>
            <br />

            <div class="row">
                <div class="col-md-6">
                    <input class="btn btn-success" type="submit" value="Buscar" />
                </div>
            </div>
        </form>
    </div>
</div>

<br />

<div class="row">
    <div id="PainelMensagem" class="col-md-12 alert fade show m-2" style="display:none" role="alert">
        <span id="Mensagem"></span>
        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
</div>


<div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="modalo" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
        </div>
    </div>
</div>

<div id="resultado">

</div>

@section Scripts {
   
    <script>
        $(document).ready(() => {
            $('#Curso').change(buscarTurnos);
            $('#Turno').change(buscarDisciplinas);
        })

        function buscarDisciplinas() {
            if ($('#Turno').val() != "") {
                $.ajax({
                    type: "GET",
                    url: "Lancamentos/BuscarDisciplinasDoCurso",
                    data: { cursoId: $('#Curso').val(), turnoId: $('#Turno').val() },
                    dataType: 'json',
                    contentType: "application/json; charset=utf-8",
                    success: function (obj) {
                        if (obj != null) {
                            var selectbox = $('#Disciplina');
                            selectbox.find('option').remove();
                            $('<option>').val("").text("Selecione").appendTo(selectbox);
                            $.each(obj, function (i, d) {
                                $('<option>').val(d.id).text(d.disciplina).appendTo(selectbox);
                            });
                        }
                    }
                });
            }
        }

        function buscarTurnos() {
            if ($('#Curso').val() != "") {
                $.ajax({
                    type: "GET",
                    url: "Lancamentos/BuscarTurnosDoCurso",
                    data: { cursoId: $('#Curso').val() },
                    dataType: 'json',
                    contentType: "application/json; charset=utf-8",
                    success: function (obj) {
                        if (obj != null) {
                            var selectbox = $('#Turno');
                            selectbox.find('option').remove();
                            $('<option>').val("").text("Selecione").appendTo(selectbox);
                            $.each(obj, function (i, d) {
                                $('<option>').val(d.id).text(d.turno).appendTo(selectbox);
                            });
                        }
                    }
                });
            }
        }

        function alunosBegin() {
            $('#formAlunos').loading();
        }

        function alunosSuccess() {
            $('#formAlunos').loading('stop');
        }
    </script>
}

SGATCC/Areas/Coordenador/Views/Lancamentos/_Aula.cshtml
@model AulaViewModel;

<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Frequência
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
    </div>
    <div class="card-body">
        <form class="form-signin" asp-controller="Lancamentos" asp-action="LancarFrequencia" data-ajax="true"
              data-ajax-method="post"
              data-ajax-begin="LancarNotasBegin"
              data-ajax-success="LancarNotasSuccess"
              id="formLancarNotas">
            <input asp-for="DisciplinaId" hidden />
            <input asp-for="AlunoId" hidden />
            <div class="form-label-group">
                <label asp-for="Aula1"></label>
                <select asp-for="Aula1" class="form-control">
                    <option value="true">Presente</option>
                    <option value="false">Ausente</option>
                </select>
            </div>
            <br />
            <div class="form-label-group">
                <label asp-for="Aula2"></label>
                <select asp-for="Aula2" class="form-control">
                    <option value="true">Presente</option>
                    <option value="false">Ausente</option>
                </select>
            </div>
            <br />
            <div class="form-label-group">
                <label asp-for="Aula3"></label>
                <select asp-for="Aula3" class="form-control">
                    <option value="true">Presente</option>
                    <option value="false">Ausente</option>
                </select>
            </div>
            <br />
            <div class="form-label-group">
                <label asp-for="Aula4"></label>
                <select asp-for="Aula4" class="form-control">
                    <option value="true">Presente</option>
                    <option value="false">Ausente</option>
                </select>
            </div>
            <br />
            <button class="btn btn-lg btn-primary btn-block " type="submit">Lançar Frequência</button>
            <hr class="my-4">
        </form>
    </div>
</div>

<script>
    function LancarNotasBegin() {
        $('#formLancarNotas').loading();
    }

    function LancarNotasSuccess(xhr) {
        $('#formLancarNotas').loading('stop');
        if (!xhr.erro) {
            $('#PainelMensagem').removeClass('alert-danger');
            $('#PainelMensagem').addClass('alert-success');
            $('#Mensagem').html(xhr.msg);
            $('#PainelMensagem').show();
            $('#modal').modal('hide');
        } else {
            $('#PainelMensagem').removeClass('alert-success');
            $('#PainelMensagem').addClass('alert-danger');
            $('#Mensagem').html(xhr.msg);
            $('#PainelMensagem').show();
            $('#modal').modal('hide');
        }

        setTimeout(() => {
            $('#PainelMensagem').hide();
        },3000)
    }
</script>

SGATCC/Areas/Coordenador/Views/Lancamentos/_LstAlunos.cshtml
@model IEnumerable<SGATCC.Areas.Coordenador.ViewModel.CriarAlunoViewModel>
<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Alunos Cadastrados
        </div>
    </div>
    <div class="card-body">
        <table class="table" id="tableUsuarios">

            <thead>
                <tr>
                    <th>Ações</th>
                    <th>
                        @Html.DisplayNameFor(x => x.FirstOrDefault().Matricula)
                    </th>
                    <th>
                        @Html.DisplayNameFor(x => x.FirstOrDefault().Nome)
                    </th>
                    <th>
                        @Html.DisplayNameFor(x => x.FirstOrDefault().DataNascimento)
                    </th>
                    <th>
                        @Html.DisplayNameFor(x => x.FirstOrDefault().Disciplina)
                    </th>
                </tr>
            </thead>
            @foreach (var item in Model)
            {
                <tbody>
                    <tr>
                        <td>
                            <a href="#" class="fas fa-calendar-check icone-admin frequencia" data-disciplina="@item.Disciplina" data-alunoId="@item.AlunoId" title="Frequência" style="margin-right:15px"></a>
                            <a href="#" class="fas fa-users icone-admin nota" data-disciplina="@item.Disciplina" data-alunoId="@item.AlunoId" title="Nota"></a>
                        </td>
                        <td>
                            @Html.DisplayFor(Model => item.Matricula)
                        </td>
                        <td>
                            @Html.DisplayFor(Model => item.Nome)
                        </td>
                        <td>
                            @Html.DisplayFor(Model => item.DataNascimento)
                        </td>
                        <td>
                            @Html.DisplayFor(Model => item.Disciplina)
                        </td>
                    </tr>
                </tbody>
            }
        </table>
    </div>
</div>

<script>
    $(document).ready(function () {

        $('.frequencia').click(function () {
            const botao = $(this);
            var alunoId = botao.attr('data-alunoId');
            var disciplina = botao.attr('data-Disciplina');

            $.ajax({
                url: 'Lancamentos/Frequencia',
                data: { alunoId: alunoId, disciplina: disciplina },
                type: 'GET',
                datatype: 'html',
                success: function (xhr) {
                    $('.modal-content').html("");
                    $('.modal-content').html(xhr);
                    $('#modal').modal();
                }
            });
        });

        $('.nota').click(function () {
            const botao = $(this);
            var alunoId = botao.attr('data-alunoId');
            var disciplina = botao.attr('data-Disciplina');

            $.ajax({
                url: 'Lancamentos/Nota',
                data: { alunoId: alunoId, disciplina: disciplina },
                type: 'GET',
                datatype: 'html',
                success: function (xhr) {
                    $('.modal-content').html("");
                    $('.modal-content').html(xhr);
                    $('#modal').modal();
                }
            });
        });
    })
</script>

SGATCC/Areas/Coordenador/Views/Lancamentos/_Nota.cshtml
@model Nota;

<div class="card">
    <div class="card-header card-admin">
        <div class="card-title">
            Nota
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>
    </div>
    <div class="card-body">
        <form class="form-signin" asp-controller="Lancamentos" asp-action="LancarNota" data-ajax="true"
              data-ajax-method="post"
              data-ajax-begin="LancarNotasBegin"
              data-ajax-success="LancarNotasSuccess"
              id="formLancarNotas">
            <input asp-for="DisciplinaId" hidden />
            <input asp-for="AlunoId" hidden />
            <div class="form-label-group">
                <label asp-for="ValorNota"></label>
               <input asp-for="ValorNota" type="number" min="0.0" max="100.0" class="form-control" />
            </div>
            <br />
            <div class="form-label-group">
                <label asp-for="Aprovado"></label>
                <select asp-for="Aprovado" class="form-control">
                    <option value="false" selected>Não</option>
                    <option value="true">Sim</option>
                </select>
            </div>
            <br />
            <button class="btn btn-lg btn-primary btn-block " type="submit">Lançar Nota</button>
            <hr class="my-4">
        </form>
    </div>
</div>

<script>
    function LancarNotasBegin() {
        $('#formLancarNotas').loading();
    }

    function LancarNotasSuccess(xhr) {
        $('#formLancarNotas').loading('stop');
        if (!xhr.erro) {
            $('#PainelMensagem').removeClass('alert-danger');
            $('#PainelMensagem').addClass('alert-success');
            $('#Mensagem').html(xhr.msg);
            $('#PainelMensagem').show();
            $('#modal').modal('hide');
        } else {
            $('#PainelMensagem').removeClass('alert-success');
            $('#PainelMensagem').addClass('alert-danger');
            $('#Mensagem').html(xhr.msg);
            $('#PainelMensagem').show();
            $('#modal').modal('hide');
        }

        setTimeout(() => {
            $('#PainelMensagem').hide();
        },3000)
    }
</script>